library(raster)
library(rasterVis)
library(ncdf4)
library(lattice)
library(mapview)

ncfile = ncdf4::nc_open('/home/abarrant/esarchive/scratch/abarrant/test_netcdf/sconcno2/2017/sconcno2_2017011400.nc')
names(ncfile$var)


#Change the Input path.
input_nc = '/home/abarrant/esarchive/scratch/abarrant/test_netcdf/sconcno2/2017/sconcno2_2017011400.nc'
varname = 'sconcno2'
nc2raster = raster(input_nc,varname = varname,band = 1)

output = '/home/abarrant/esarchive/scratch/abarrant/test_netcdf/sconcno2/2017/raster_sconcno2_2017011400.tif'
writeRaster(nc2raster,output,format = 'GTiff',overwrite = TRUE)
#Change the output path to save Geotif data.



#To output a quick view for the dataset
png("F:\\plot2019.png",
    height = 15,
    width = 20,
    units = 'cm',
    res = 1000)
print(levelplot(nc2raster))
dev.off()


nc2raster = stack(input_nc,varname = varname)

# PM2.5 files from washington--------------------------------------


nc_file <- nc_open("/home/abarrant/esarchive/scratch/abarrant/test_netcdf/V6GL02.02.CNNPM25.EU.202205-202205.nc")
pollutant <- "PM25"

lon <- ncvar_get(nc_file, "lon")
lat <- ncvar_get(nc_file, "lat")

nc_var.array <- ncvar_get(nc_file, pollutant) 

#generation of raster
r_nc_var <- raster(t(nc_var.array), xmn=min(lon), xmx=max(lon), ymn=min(lat), ymx=max(lat), crs=CRS("+proj=longlat +ellps=WGS84 +datum=WGS84 +no_defs+ towgs84=0,0,0"))
r_nc_var <- flip(r_nc_var, direction='y') 
mapview(r_nc_var)

cat_box <- extent(0, 3.5, 40.4, 43)
r_nc_var_cat <- crop(r_nc_var, cat_box)
mapview(r_nc_var_cat)


#sws_box <- extent(6, 10, 45.8, 47.6)


#----------------------------------


mapview_sat <- function(name_file){
  nc_file <- nc_open(name_file)
  pollutant <- "PM25"
  
  lon <- ncvar_get(nc_file, "lon")
  lat <- ncvar_get(nc_file, "lat")
  
  nc_var.array <- ncvar_get(nc_file, pollutant) 
  
  #generation of raster
  r_nc_var <- raster(t(nc_var.array), xmn=min(lon), xmx=max(lon), ymn=min(lat), ymx=max(lat), crs=CRS("+proj=longlat +ellps=WGS84 +datum=WGS84 +no_defs+ towgs84=0,0,0"))
  r_nc_var <- flip(r_nc_var, direction='y') 
  cat_box <- extent(0, 3.5, 40.4, 43)
  r_nc_var_cat <- crop(r_nc_var, cat_box)
  mapview(r_nc_var_cat)
}


mapview_sat("/home/abarrant/esarchive/scratch/abarrant/test_netcdf/V6GL02.02.CNNPM25.EU.202205-202205.nc")
mapview_sat("/home/abarrant/esarchive/scratch/abarrant/test_netcdf/V6GL02.02.CNNPM25.EU.201901-201912.nc")